package b4a.example;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new anywheresoftware.b4a.ShellBA(this.getApplicationContext(), null, null, "b4a.example", "b4a.example.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.example", "b4a.example.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "b4a.example.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
//        try {
//            if (processBA.subExists("activity_actionbarhomeclick")) {
//                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
//                    getClass().getMethod("getActionBar").invoke(this), true);
//                BA.Log("adding event");
//            }
//        } catch (Exception e) {
//            e.printStackTrace();
//        }
		return true;
	}   
// @Override
// public boolean onOptionsItemSelected(android.view.MenuItem item) {
//    if (item.getItemId() == 16908332) {
//        processBA.raiseEvent(null, "activity_actionbarhomeclick");
//        return true;
//    }
//    else
//        return super.onOptionsItemSelected(item); 
//}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}



public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}
public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}

public static void killProgram() {
     {
            Activity __a = null;
            if (main.previousOne != null) {
				__a = main.previousOne.get();
			}
            else {
                BA ba = main.mostCurrent.processBA.sharedProcessBA.activityBA.get();
                if (ba != null) __a = ba.activity;
            }
            if (__a != null)
				__a.finish();}

}
public anywheresoftware.b4a.keywords.Common __c = null;
public static String  _activity_create(boolean _firsttime) throws Exception{
RDebugUtils.currentModule="main";
anywheresoftware.b4a.agraham.byteconverter.ByteConverter _bconv = null;
anywheresoftware.b4a.objects.StringUtils _su = null;
byte[] _key = null;
byte[] _data = null;
byte[] _bytes = null;
byte[] _iv = null;
String _ssecretkey = "";
anywheresoftware.b4a.agraham.encryption.CipherWrapper.KeyGeneratorWrapper _kg = null;
anywheresoftware.b4a.agraham.encryption.CipherWrapper _c = null;
anywheresoftware.b4a.agraham.encryption.CipherWrapper.MessageDigestWrapper _md = null;
anywheresoftware.b4a.objects.collections.List _list1 = null;
byte[] _byte_temp = null;
String _cadena = "";
anywheresoftware.b4a.objects.collections.List _list2 = null;
anywheresoftware.b4a.objects.collections.List _list3 = null;
anywheresoftware.b4a.objects.collections.List _list4 = null;
int _i = 0;
RDebugUtils.currentLine=131072;
 //BA.debugLineNum = 131072;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
RDebugUtils.currentLine=131077;
 //BA.debugLineNum = 131077;BA.debugLine="Dim Bconv As ByteConverter";
_bconv = new anywheresoftware.b4a.agraham.byteconverter.ByteConverter();
RDebugUtils.currentLine=131078;
 //BA.debugLineNum = 131078;BA.debugLine="Dim su As StringUtils";
_su = new anywheresoftware.b4a.objects.StringUtils();
RDebugUtils.currentLine=131079;
 //BA.debugLineNum = 131079;BA.debugLine="Dim key(0) As Byte";
_key = new byte[(int) (0)];
;
RDebugUtils.currentLine=131080;
 //BA.debugLineNum = 131080;BA.debugLine="Dim data(0) As Byte";
_data = new byte[(int) (0)];
;
RDebugUtils.currentLine=131081;
 //BA.debugLineNum = 131081;BA.debugLine="Dim bytes(0) As Byte";
_bytes = new byte[(int) (0)];
;
RDebugUtils.currentLine=131082;
 //BA.debugLineNum = 131082;BA.debugLine="Dim iv(0) As Byte";
_iv = new byte[(int) (0)];
;
RDebugUtils.currentLine=131083;
 //BA.debugLineNum = 131083;BA.debugLine="Dim sSecretKey As String = \"password\"";
_ssecretkey = "password";
RDebugUtils.currentLine=131086;
 //BA.debugLineNum = 131086;BA.debugLine="Dim Kg As KeyGenerator";
_kg = new anywheresoftware.b4a.agraham.encryption.CipherWrapper.KeyGeneratorWrapper();
RDebugUtils.currentLine=131087;
 //BA.debugLineNum = 131087;BA.debugLine="Dim c As Cipher";
_c = new anywheresoftware.b4a.agraham.encryption.CipherWrapper();
RDebugUtils.currentLine=131088;
 //BA.debugLineNum = 131088;BA.debugLine="Dim md As MessageDigest";
_md = new anywheresoftware.b4a.agraham.encryption.CipherWrapper.MessageDigestWrapper();
RDebugUtils.currentLine=131090;
 //BA.debugLineNum = 131090;BA.debugLine="c.Initialize(\"AES\")";
_c.Initialize("AES");
RDebugUtils.currentLine=131091;
 //BA.debugLineNum = 131091;BA.debugLine="Kg.Initialize(\"AES\")";
_kg.Initialize("AES");
RDebugUtils.currentLine=131092;
 //BA.debugLineNum = 131092;BA.debugLine="Kg.KeyFromBytes(md.GetMessageDigest(sSecretKey.GetBytes(\"UTF8\"), \"MD5\"))";
_kg.KeyFromBytes(_md.GetMessageDigest(_ssecretkey.getBytes("UTF8"),"MD5"));
RDebugUtils.currentLine=131095;
 //BA.debugLineNum = 131095;BA.debugLine="Dim List1 As List";
_list1 = new anywheresoftware.b4a.objects.collections.List();
RDebugUtils.currentLine=131096;
 //BA.debugLineNum = 131096;BA.debugLine="List1.Initialize";
_list1.Initialize();
RDebugUtils.currentLine=131097;
 //BA.debugLineNum = 131097;BA.debugLine="List1.Add(\"3fff 01\")";
_list1.Add((Object)("3fff 01"));
RDebugUtils.currentLine=131098;
 //BA.debugLineNum = 131098;BA.debugLine="List1.Add(\"3fff 02\")";
_list1.Add((Object)("3fff 02"));
RDebugUtils.currentLine=131099;
 //BA.debugLineNum = 131099;BA.debugLine="Log(List1)";
anywheresoftware.b4a.keywords.Common.Log(BA.ObjectToString(_list1));
RDebugUtils.currentLine=131101;
 //BA.debugLineNum = 131101;BA.debugLine="Dim byte_temp() As Byte";
_byte_temp = new byte[(int) (0)];
;
RDebugUtils.currentLine=131102;
 //BA.debugLineNum = 131102;BA.debugLine="Dim cadena As String";
_cadena = "";
RDebugUtils.currentLine=131103;
 //BA.debugLineNum = 131103;BA.debugLine="Dim List2 As List";
_list2 = new anywheresoftware.b4a.objects.collections.List();
RDebugUtils.currentLine=131104;
 //BA.debugLineNum = 131104;BA.debugLine="List2.Initialize";
_list2.Initialize();
RDebugUtils.currentLine=131106;
 //BA.debugLineNum = 131106;BA.debugLine="byte_temp=su.DecodeBase64(List1.Get(0))";
_byte_temp = _su.DecodeBase64(BA.ObjectToString(_list1.Get((int) (0))));
RDebugUtils.currentLine=131107;
 //BA.debugLineNum = 131107;BA.debugLine="data = c.Encrypt(byte_temp, Kg.key, False)";
_data = _c.Encrypt(_byte_temp,(java.security.Key)(_kg.getKey()),anywheresoftware.b4a.keywords.Common.False);
RDebugUtils.currentLine=131108;
 //BA.debugLineNum = 131108;BA.debugLine="cadena= su.EncodeBase64(data)";
_cadena = _su.EncodeBase64(_data);
RDebugUtils.currentLine=131109;
 //BA.debugLineNum = 131109;BA.debugLine="List2.Add(cadena)";
_list2.Add((Object)(_cadena));
RDebugUtils.currentLine=131110;
 //BA.debugLineNum = 131110;BA.debugLine="byte_temp=su.DecodeBase64(List1.Get(1))";
_byte_temp = _su.DecodeBase64(BA.ObjectToString(_list1.Get((int) (1))));
RDebugUtils.currentLine=131111;
 //BA.debugLineNum = 131111;BA.debugLine="data = c.Encrypt(byte_temp, Kg.key, False)";
_data = _c.Encrypt(_byte_temp,(java.security.Key)(_kg.getKey()),anywheresoftware.b4a.keywords.Common.False);
RDebugUtils.currentLine=131112;
 //BA.debugLineNum = 131112;BA.debugLine="cadena= su.EncodeBase64(data)";
_cadena = _su.EncodeBase64(_data);
RDebugUtils.currentLine=131113;
 //BA.debugLineNum = 131113;BA.debugLine="List2.Add(cadena)";
_list2.Add((Object)(_cadena));
RDebugUtils.currentLine=131114;
 //BA.debugLineNum = 131114;BA.debugLine="File.WriteList(File.DirDefaultExternal, \"String.txt\", List2)";
anywheresoftware.b4a.keywords.Common.File.WriteList(anywheresoftware.b4a.keywords.Common.File.getDirDefaultExternal(),"String.txt",_list2);
RDebugUtils.currentLine=131116;
 //BA.debugLineNum = 131116;BA.debugLine="Log(List2)";
anywheresoftware.b4a.keywords.Common.Log(BA.ObjectToString(_list2));
RDebugUtils.currentLine=131118;
 //BA.debugLineNum = 131118;BA.debugLine="Dim List3 As List=File.ReadList(File.DirDefaultExternal, \"String.txt\")";
_list3 = new anywheresoftware.b4a.objects.collections.List();
_list3 = anywheresoftware.b4a.keywords.Common.File.ReadList(anywheresoftware.b4a.keywords.Common.File.getDirDefaultExternal(),"String.txt");
RDebugUtils.currentLine=131119;
 //BA.debugLineNum = 131119;BA.debugLine="Dim List4 As List";
_list4 = new anywheresoftware.b4a.objects.collections.List();
RDebugUtils.currentLine=131120;
 //BA.debugLineNum = 131120;BA.debugLine="List4.Initialize";
_list4.Initialize();
RDebugUtils.currentLine=131121;
 //BA.debugLineNum = 131121;BA.debugLine="Log(List3)";
anywheresoftware.b4a.keywords.Common.Log(BA.ObjectToString(_list3));
RDebugUtils.currentLine=131123;
 //BA.debugLineNum = 131123;BA.debugLine="For i=0 To List3.Size-1";
{
final int step41 = 1;
final int limit41 = (int) (_list3.getSize()-1);
for (_i = (int) (0); (step41 > 0 && _i <= limit41) || (step41 < 0 && _i >= limit41); _i = ((int)(0 + _i + step41))) {
RDebugUtils.currentLine=131124;
 //BA.debugLineNum = 131124;BA.debugLine="byte_temp=su.DecodeBase64(List3.Get(i))";
_byte_temp = _su.DecodeBase64(BA.ObjectToString(_list3.Get(_i)));
RDebugUtils.currentLine=131125;
 //BA.debugLineNum = 131125;BA.debugLine="data = c.Decrypt(byte_temp, Kg.key, False)";
_data = _c.Decrypt(_byte_temp,(java.security.Key)(_kg.getKey()),anywheresoftware.b4a.keywords.Common.False);
RDebugUtils.currentLine=131126;
 //BA.debugLineNum = 131126;BA.debugLine="cadena= su.EncodeBase64(data)";
_cadena = _su.EncodeBase64(_data);
RDebugUtils.currentLine=131127;
 //BA.debugLineNum = 131127;BA.debugLine="List4.Add(cadena)";
_list4.Add((Object)(_cadena));
 }
};
RDebugUtils.currentLine=131130;
 //BA.debugLineNum = 131130;BA.debugLine="Log(List4)";
anywheresoftware.b4a.keywords.Common.Log(BA.ObjectToString(_list4));
RDebugUtils.currentLine=131133;
 //BA.debugLineNum = 131133;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
RDebugUtils.currentModule="main";
RDebugUtils.currentLine=262144;
 //BA.debugLineNum = 262144;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
RDebugUtils.currentLine=262146;
 //BA.debugLineNum = 262146;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
RDebugUtils.currentModule="main";
RDebugUtils.currentLine=196608;
 //BA.debugLineNum = 196608;BA.debugLine="Sub Activity_Resume";
RDebugUtils.currentLine=196610;
 //BA.debugLineNum = 196610;BA.debugLine="End Sub";
return "";
}
}